﻿// This is part of the SofaJpl DLL class library.
// There are only 2 lines of code in this file. The rest is notes.
using System;
[assembly: CLSCompliant(true)]

// revision notes
#if false

2015-03-18 Would be convenient if JulianDate had a method similar to DatePart which produced
a JulianDate, and a method similar to TimePart which produced a Duration. Maybe call them
Date() and Time()? Or ToDate() and ToTime()? [c/w 2017-10-26]

2015-06-10 Add a PVVector constructor which takes six doubles. [c/w 2017-10-26]

2015-08-26  Finished. Compiled with no warnings. Full self test successful.

2015-08-30  Maybe add an overload to Atmosphere.Refract() to take a Spherical object?
[c/w 2015-09-05]

2015-08-31  Maybe a JulianDate ToTimeFields() method?  [already present 2015-09-05]

    Friendlier star name lookup in catalog, so a full and exact match isn't necessary.

2015-09-02  Star constructor which takes a StarCatalogEntry. Should it assume epoch J1991.25?
[c/w 2015-09-05]

2015-09-04  Should Body.TopocentricGeometric() return a PVVector? The other geometric places do.
[c/w 2015-09-05]

2015-09-05  In JulianDate, would be nice if ToTimeFields() had a 1-param overload to generate
result in the Gregorian calendar by default. [c/w 2017-10-26]

2015-09-13  Espenak's delta T polynomials seem to have only slight discontinuities at their
junctions, so the smoothing in the DeltaT class need only cover a short span. About .1 year?
Also, the XML comments ought to credit Espenak for the polys. [superseded by new DeltaT class
2018-02-20]

2015-09-26  2015-08-28T02:59:60.0000 UTC is the result if arcsecAccuracy = .001f in the SofaJpl
demo program. Problem goes away if the variable is changed to double. [c/w 2017-12-21]

2016-03-02  Exception in Demo2 program at 2016-03-01T00:00:00.0000, DE430 ephemeris, Mercury
geocentric geometric place:

Unhandled Exception: System.IndexOutOfRangeException: Index was outside the boun
ds of the array.
   at HirosePS.SofaJpl.JplEphemeris.interpolate(JulianDate tdb, Int32 column, In
t32[] stateList)
   at HirosePS.SofaJpl.JplEphemeris.GetState(JulianDate tdb, Int32[] stateList)
   at HirosePS.SofaJpl.JplEphemeris.Read(JulianDate tdb, Body target, Body origi
n)
   at HirosePS.SofaJpl.JplBody.GeocentricGeometric(JulianDate tdb)
   at SofaJplDemo.Main(String[] args) in c:\Users\Stan\Documents\Visual Studio 2
013\Projects\SofaJplDemoCs2\SofaJplDemoCs2\Program.cs:line 323

[c/w 2017-08-14]

2017-01-03  Since the "TV dinner" methods in RMatrix use the 2000B nutation model, the GAST
method in the Angle class ought to do the same. Retain the current Gast06a method. [I don't think
any change is necessary since Gast00b() is available. 2018-02-20]

2017-02-13  Modifying Sexagesimal self test to investigate the bug noted above on 2015-09-26.
[bug eliminated 2017-12-21]

2017-03-05  JusianDate constructor messes up if seconds are negative. E.g., 1855, 9, 7, 8, 5, -1
translates to 1855-09-06T15:54:59. [c/w 2018-02-20]

2017-08-15  JPL ephemeris conversion from ASCII to binary may trigger an error message that the
header does not have the expected number of constants. This is caused by too-strict error checking.
[c/w 2018-02-21]

2018-02-19  Add AtMidnight() to JulianDate to return an instance at 0h same date. [c/w 2018-02-20]

2018-04-20  ALL SELF TESTS PASS! Only remaining task is to build the release version of SofaJpl 2.1.


IDEAS FOR NEXT VERSION

2018-04-23 Utc constructor with year, month, day, hour, minute, second, Julian arguments
would be nice. Augment the set of constructors. [c/w 2018-06-04]

2018-04-24 I re-iterate the need for Angle.Gast06b() as stated on 2017-01-03. Yes, there's a
Gast00b() method, but that's for the 2000 precession model. [c/w 2018-06-05]

2018-04-28  Body.TopocentricAstrometric() takes a Vector parameter with observer position, but
TopocentricApparent() takes a PVVector. Shouldn't the latter take a Vector too? [No. Observer
velocity is needed to account for aberration. 2018-06-05]

2018-05-06  JulianDate class needs TTToTai() and TaiToTT() methods. [Not really. The pattern I have
established is to put the conversions with a variable offset, such as TT to TDB, in JulianDate.
But if the offset is fixed, such as TT to TAI, it's in Duration. No change. 2018-06-05]

BUG
2018-05-14 UTC display is incorrect at 2016-12-31 23:59:60. Angle accuracy .01'. [fixed 2018-06-03]


2018-07-19 XML comments that describe each class could perhaps be amplified with the sort of
comments found in the demo programs. E.g., state that a Sexagesimal contains theta, phi, and
radius at double precision.

#endif
